<template>
  <b-container fluid>
    <b-row>
      <b-col cols="12 mt-2">
        <h2>{{ title }}</h2>
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12 mt-2">
        <div class="d-flex justify-content-between position-relative">
          <div>
            <VRoleFilter label="Rol" v-model="filters.role" @change="$refs.table_person.refresh()" />
          </div>
        </div>
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <b-table
          ref="table_person"
          :fields="fields"
          class="mt-4"
          hover
          responsive
          stacked="sm"
          :busy.sync="isBusy"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          no-local-sorting
          :items="tableProvider"
          :current-page="currentPage"
          :per-page="perPage"
          @row-clicked="onRowClicked"
        >
          <template v-slot:cell(consumer_object)="data">{{ data.item.consumer_object.name }}</template>
          <template v-slot:cell(resource__name)="data">{{ data.item.resource_object.name }}</template>
          <template v-slot:cell(owner__name)="data">{{ data.item.owner_object.name }}</template>
          <template v-slot:cell(owner__region__name)="data">
            {{ data.item.owner_object.region_object.name }}
          </template>
          <template v-slot:cell(role_disambiguation)="data">
            {{ (mappedRoleDisambiguation[data.item.role_disambiguation] || {}).name || '--' }}
          </template>
        </b-table>
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <b-pagination
          :total-rows="totalRows"
          :per-page="perPage"
          v-model="currentPage"
          align="center"
        />
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import { mapState, mapActions } from "vuex";
import VRoleFilter from "@/components/VRoleFilter.vue";
// import VRoleText from "@/components/VRoleText.vue";

export default {
  name: "person-list",
  components: { VRoleFilter },
  props: {
    preset_filters: {
      type: Object,
      default: undefined
    },
    title: {
      type: String,
      default: "Personas"
    }
  },
  data() {
    return {
      filters: {
        role: null
      },
      loading: false,
      isBusy: false,
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      sortBy: null,
      sortDesc: false
    };
  },
  computed: {
    ...mapState({
      mappedRoleDisambiguation: state => state.utils.mappedRoleDisambiguation
    }),
    fields() {
      return [
        {
          key: "pk",
          label: "ID",
          sortable: true
        },
        {
          key: "name",
          label: "Nombre",
          sortable: true
        },
        {
          key: "role_disambiguation",
          label: "Tipo de Usuario",
          sortable: true
        },
        {
          key: "region",
          label: "Región",
          sortable: true
        },
        {
          key: "address",
          label: "Calle"
        },
        {
          key: "number",
          label: "Número"
        },
        {
          key: "city",
          label: "Localidad"
        },
        {
          key: "phone",
          label: "Teléfono"
        }
      ];
    }
  },
  mounted() {
    if (this.preset_filters) {
      this.filters = Object.assign({}, this.filters, this.preset_filters);
    }
    if (this.mappedRoleDisambiguation.length <= 0) {
      this.LOAD_ROLE_DISAMBIGUATION();
    }
  },
  methods: {
    ...mapActions({
      LOAD_ROLE_DISAMBIGUATION: "utils/LOAD_ROLE_DISAMBIGUATION"
    }),
    tableProvider() {
      this.loading = false;
      let offset = 0;
      var filters = {};
      if (this.perPage && this.currentPage) {
        offset = this.perPage * (this.currentPage - 1);
      }
      filters.offset = offset;
      filters.limit = this.perPage;
      if (this.sortBy) {
        filters["ordering"] = this.sortBy;
        if (this.sortDesc) {
          filters["ordering"] = "-" + filters["ordering"];
        }
      }
      filters = Object.assign(filters, this.filters);
      const uri = this.$parseurl(
        "/logistica/middle/person/{person_pk}/foreignperson/",
        {
          person_pk: localStorage.getItem("pk_person")
        },
        filters
      );
      return new Promise((resolve, reject) => {
        this.$fetchget(uri).then(res => {
          res.json().then(data => {
            if (res.ok) {
              const items = data.results;
              this.loading = false;
              this.totalRows = data.count;
              resolve(items);
              return items;
            } else {
              // TODO: LANZAR ERROR
              reject("error");
            }
          });
        });
      });
    },
    onRowClicked(data) {
      this.$emit("person-click", Object.assign({}, data));
    },
    refresh() {
      this.$refs.table_person.refresh();
    }
  }
};
</script>
<style>
</style>
